<template>
  <div>
    <div class="row">
      <div class="columns" :class="column" style="position: relative">
        <label for="cardNumber">Номер карты</label>
        <input id="cardNumber"
               name="номер карты"
               class="acceptance__content-input back-img-input"
               v-mask="masks"
               v-model="numberCard"
               placeholder="0000-0000-0000-0000"
               type="tel"
               v-validate="'required|cardNumberValidate'"
               data-vv-validate-on="blur"
               :class="{error: vErrors.has('номер карты')}"
               :style="{background: `url('${cardImg}')`}"
               :disabled="blocker"
               @input="$emit('cardData', {numberCard: numberCard, month: '', year: '', holder: ''})"
               @keyup.enter="$emit('enter')"
        />
        <!--<img v-show="cardImg" :src="cardImg" class="card-img">-->
        <validate-message v-show="vErrors.has('номер карты')">
          {{ vErrors.first('номер карты') }}
        </validate-message>
      </div>
      <drop-date v-if="type_payment === 1" class="columns" :class="column" ref="sample" @getDropDate="getDropDate"></drop-date>
    </div>
    <token-data v-if="type_payment === 8" ref="tds" @getTokenData="getTokenData" :blocker="blocker" @enter="$emit('enter')"></token-data>
    <div class="row">
      <slot name="footer"></slot>
    </div>
  </div>
</template>

<script>
  import cardType from 'credit-card-type'
  import Checkbox from '@/components/Checkbox';
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import DropDate from './Sample/DropDate'
  import TokenData from './TDS/TokenData'
  const LOAN_PDL = 1;
  const LOAN_INSTALLMENT = 8;

  export default {
		name: 'CardBuilding',
    components: {DropDate, TokenData, Checkbox},
    mixins: [ValidateMessage],
    props: {
		  type: {
		    default: 1
      },
      column: {
		    default: 'twelve'
      },
      blocker: {
        type: Boolean,
        default: false
      }
    },
    data () {
      return {
        masks: '####-####-####-####',
        numberCard: '',
        cardImg: '',
        card: {
          number: '',
          holder: '',
          cvc: '',
          year: '',
          month: ''
        }
      }
    },
    computed: {
      type_payment () {
        return this.type === 8 ? LOAN_INSTALLMENT : LOAN_PDL
      }
    },
    watch: {
      'numberCard' (card) {
        let symbols = card.split('-');
        this.series = symbols;
        this.getMask(cardType(symbols[0]));
        let img = cardType(symbols[0]);
        this.cardImg = (card.length !== 0 && img.length !== 0) ? `/lk/static/img/my-accounts/${img[0].type}.png` : ''; // подставляем иконку типа карты (виза, мастер-кард и т.д)
        this.card.number = symbols.join('');
      },
      'formatter' (date) {
        this.card.month = date.slice(0, 2);
        this.card.year = date.slice(3, 5)
      }
    },
    methods: {
      getDropDate ({month, year}) {
        this.card.month = month;
        this.card.year = year
      },
      getAnswer (main = 1) { // в аргументе указывается и передается, будет ли карта главной картой у пользователя или нет (by default 1 - главная)
		  /**
		   * ВЫБИРАЕМ ТИП ПРИВЯЗКА КАРТЫ:
           *
           * commonTie() - функция будет привязывать все карты без проверки на наличие TDS, есть она вообще на картах или нет
           * tieWithTDS() - данная функция будет проверять, есть на карте TDS или нет, в случае если да, вылезит iframe от банка, в случае если нет - нащ механизм
           *
		   */
        this.type_payment === 1 ? this.commonTie(main) : this.tieWithTDS() //
      },
      async commonTie (main) {
        let listValid = [await this.$validator.validateAll(), await this.$refs.sample.$validator.validateAll()];
        listValid = listValid.every((key) => key === true);
        if (listValid) {
          let card = {
            description: this.card.number,
            valid_month: this.card.month,
            valid_year: this.card.year,
            main: main,
            activated: 1,
            type: 1
          };
          this.AJAX_LOADING({
            caption: 'Загрузка',
            waitingTitle: 'Обработка данных',
            name: 'rootFixed',
            isShow: true
          });
          this.BUTTON_LOADING(true);

          const valid = await this.$backend.api.accounts.checkCard(card).then(() => {
            return Promise.resolve(true);
          }).catch((e) => {
			  this.$emit('resultError', e)
          	return Promise.resolve(false);
          });

          if(!valid) {
          	this.$toastr.error('Ошибка при добавлении карты. Укажите другую карту или выберите другой способ получения', 'Ошибка');
          	this.AJAX_LOADING(false);
          	this.BUTTON_LOADING(false);
          	return false;
          }

          this.$backend.api.accounts.create(card)
            .then(({data}) => {
              this.$toastr.success('Карта успешно добавлена.', 'Успешно');
              this.$emit('resultSuccess', data)
            })
            .catch((e) => {
              this.$error(e, {
                  'black-list-validation-error': "На данную карту нельзя получить займ, укажите другую карту или другой способ получения",
                  'description-add-validation-error': 'Ошибка при добавлении карты. Укажите другую карту или выберите другой способ получения',
                  'valid_year-validation-error': 'Неверный срок действия карты (год)',
                  'valid_month-validation-error': 'Неверный срок действия карты (месяц)',
                  'card-expired-error': 'Срок действия карты истек.'
              }, 'Ошибка при добавлении карты. Укажите другую карту или выберите другой способ получения');
  			  this.$emit('resultError', e)

            })
            .finally(() => {
              this.AJAX_LOADING(false);
              this.BUTTON_LOADING(false);
            })
        } else {
          this.$toastr.error('Заполните все обязательные поля', 'Ошибка');
          this.$emit('resultError')
        }
      },
      getMask (mask) {
        if (mask.length !== 0) {
          let largest = Math.max.apply(Math, mask[0].lengths);
          switch (largest) {
            case 19:
              this.masks = '####-####-####-#######';
              break;
            case 18:
              this.masks = '####-####-####-######';
              break;
            default:
              this.masks = '####-####-####-####';
              break;
          }
        } else {
          this.masks = '####-####-####-####'
        }
      },
      getTokenData ({month, year, cvc, holder}) {
        this.card.month = month;
        this.card.year = '20' + year;
        this.card.cvc = cvc;
        this.card.holder = holder;
        this.$emit('cardData', {numberCard: this.numberCard, month: month, year: year, holder: holder})
      },
      async tieWithTDS () {
        let listValid = [await this.$validator.validateAll(), await this.$refs.tds.$validator.validateAll()];
        listValid = listValid.every((key) => key === true);
        if (listValid) {
			this.AJAX_LOADING({
                caption: 'Загрузка',
                waitingTitle: 'Обработка данных',
                name: 'rootFixed',
                isShow: true
            });
          this.BUTTON_LOADING(true);

            const checkCardData = {
            	type: 1,
                name: "",
                main: 1,
                valid_year: Number(this.card.year),
                valid_month: Number(this.card.month),
                description: this.card.number,
            }
			const valid = await this.$backend.api.accounts.checkCard(checkCardData).then(() => {
				return Promise.resolve(true);
			}).catch((e) => {
				this.$emit('resultError', e)
				return Promise.resolve(false);
			});

			if(!valid) {
				this.$toastr.error('Ошибка при добавлении карты. Укажите другую карту или выберите другой способ получения', 'Ошибка');
				this.AJAX_LOADING(false);
				this.BUTTON_LOADING(false);
				return false;
			}

			this.$backend.api.payment.create.token({
              card: this.card
            })
            .then(({data}) => {
              if (data.data.type === 'tds') {
                this.$emit('resultTDS', data)
              } else {
                this.$toastr.success('Мы временно списали небольшую сумму с Вашей карты. Введите ее для подтверждения.', 'Подтвердите, что карта ваша.');
                this.$emit('resultTDS', {id: data.data.id, numberCard: this.numberCard})
              }
            })
            .catch((error) => {
              this.$toastr.error('Ошибка при добавлении карты. Укажите другую карту или выберите другой способ получения', 'Ошибка');
              this.blocker = false;
              console.log('Данная карта не может быть привязана', error);
			  this.$emit('resultError', error)
            })
            .finally(() => {
              this.AJAX_LOADING(false);
              this.BUTTON_LOADING(false);
            })

        } else {
          this.$toastr.error('Заполните все обязательные поля', 'Ошибка')
        }
      }
    }
	}
</script>

<style scoped>
  img.card-img {
    position: absolute;
    top: 40px;
    right: 20px;
    width: 35px;
  }
  .back-img-input {
    background-repeat: no-repeat !important;
    background-size: 40px 25px !important;
    background-position: right 20px center !important;
  }
  .red {
    margin-top: 0px;
  }
</style>
